package ar.com.drk.drkspiderjava.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import ar.com.drk.drkspiderjava.DRKTools;
import ar.com.drk.drkspiderjava.model.WebTreeModel;
import ar.com.drk.drkspiderjava.model.WebTreeNode;

import javax.swing.JPasswordField;

public class SiteOpenDlg extends JDialog {
	private static final long serialVersionUID = 1266346402452883021L;
	
	private JPanel controls = null;
	private JPanel buttons = null;
	private JButton btnOk = null;
	private JButton btnCancel = null;
	private JLabel lbl0;
	private JTextField url = null;
	private JLabel lbl2;
	private JSlider slide_depth = null;
	private JLabel depth_lbl = null;
	private JCheckBox keepContent;
	private JLabel lbl3;
	private JLabel lblRobotstxt;
	private JCheckBox obeyRobots;
	
	public boolean ok = false;
	private WebTreeModel document;
	private JScrollPane exclude_scroll;
	private JTextArea excludes;
	private JLabel lblUsernamepassword;
	private JTextField username;
	private JPasswordField password;
	private String old_username = "";
	private JCheckBox form_traversing;
	private JLabel lblFormTraversiong;
	
	/**
	 * This is the default constructor
	 */
	public SiteOpenDlg(Frame owner) {
		super(owner);
		this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		this.setModal(true);

		controls = new JPanel();
		GridBagLayout gbl_jContentPane = new GridBagLayout();
		controls.setLayout(gbl_jContentPane);
		
		GridBagConstraints gbc_lbl0 = new GridBagConstraints();
		gbc_lbl0.gridx = 0;
		gbc_lbl0.insets = new Insets(5, 5, 5, 5);
		gbc_lbl0.anchor = GridBagConstraints.EAST;
		gbc_lbl0.gridy = 0;
		lbl0 = new JLabel();
		lbl0.setText("URL:");
		controls.add(lbl0, gbc_lbl0);
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints2.gridy = 0;
		gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
		gridBagConstraints2.gridwidth = 3;
		gridBagConstraints2.gridx = 2;
		controls.add(getUrl(), gridBagConstraints2);
		GridBagConstraints gbc_lblUsernamepassword = new GridBagConstraints();
		gbc_lblUsernamepassword.anchor = GridBagConstraints.EAST;
		gbc_lblUsernamepassword.insets = new Insets(5, 5, 5, 5);
		gbc_lblUsernamepassword.gridx = 0;
		gbc_lblUsernamepassword.gridy = 1;
		controls.add(getLblUsernamepassword(), gbc_lblUsernamepassword);
		GridBagConstraints gbc_username = new GridBagConstraints();
		gbc_username.weightx = 0.5;
		gbc_username.gridwidth = 2;
		gbc_username.insets = new Insets(5, 5, 5, 5);
		gbc_username.fill = GridBagConstraints.HORIZONTAL;
		gbc_username.gridx = 2;
		gbc_username.gridy = 1;
		controls.add(getUsername(), gbc_username);
		GridBagConstraints gbc_password = new GridBagConstraints();
		gbc_password.weightx = 0.5;
		gbc_password.insets = new Insets(5, 5, 5, 5);
		gbc_password.fill = GridBagConstraints.HORIZONTAL;
		gbc_password.gridx = 4;
		gbc_password.gridy = 1;
		controls.add(getPassword(), gbc_password);

		
		GridBagConstraints depth_lbl_constraints = new GridBagConstraints();
		depth_lbl_constraints.gridx = 2;
		depth_lbl_constraints.insets = new Insets(5, 5, 5, 5);
		depth_lbl_constraints.gridy = 2;
		depth_lbl = new JLabel();
		depth_lbl.setText("3");
		controls.add(depth_lbl, depth_lbl_constraints);
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridwidth = 2;
		gridBagConstraints21.insets = new Insets(5, 5, 5, 5);
		gridBagConstraints21.fill = GridBagConstraints.BOTH;
		gridBagConstraints21.gridy = 2;
		gridBagConstraints21.weightx = 1.0;
		gridBagConstraints21.weighty = 0.0;
		gridBagConstraints21.gridx = 3;
		controls.add(getDepth(), gridBagConstraints21);
		GridBagConstraints gbc_lbl2 = new GridBagConstraints();
		gbc_lbl2.ipadx = 4;
		gbc_lbl2.gridx = 0;
		gbc_lbl2.anchor = GridBagConstraints.EAST;
		gbc_lbl2.insets = new Insets(5, 5, 5, 5);
		gbc_lbl2.gridy = 2;
		lbl2 = new JLabel();
		lbl2.setText("Maximum depth:");
		controls.add(lbl2, gbc_lbl2);
		GridBagConstraints gbc_lblFormTraversiong = new GridBagConstraints();
		gbc_lblFormTraversiong.anchor = GridBagConstraints.EAST;
		gbc_lblFormTraversiong.insets = new Insets(5, 5, 5, 5);
		gbc_lblFormTraversiong.gridx = 0;
		gbc_lblFormTraversiong.gridy = 3;
		controls.add(getLblFormTraversiong(), gbc_lblFormTraversiong);
		GridBagConstraints gbc_form_traversing = new GridBagConstraints();
		gbc_form_traversing.anchor = GridBagConstraints.WEST;
		gbc_form_traversing.gridwidth = 3;
		gbc_form_traversing.insets = new Insets(5, 5, 5, 5);
		gbc_form_traversing.gridx = 2;
		gbc_form_traversing.gridy = 3;
		controls.add(getFormTraversing(), gbc_form_traversing);

		GridBagConstraints gbc_lbl3 = new GridBagConstraints();
		gbc_lbl3.anchor = GridBagConstraints.EAST;
		gbc_lbl3.insets = new Insets(5, 5, 5, 5);
		gbc_lbl3.gridx = 0;
		gbc_lbl3.gridy = 4;
		controls.add(getLbl3(), gbc_lbl3);
		GridBagConstraints gbc_keepContent = new GridBagConstraints();
		gbc_keepContent.anchor = GridBagConstraints.WEST;
		gbc_keepContent.insets = new Insets(5, 5, 5, 5);
		gbc_keepContent.gridwidth = 3;
		gbc_keepContent.gridx = 2;
		gbc_keepContent.gridy = 4;
		controls.add(getKeepContent(), gbc_keepContent);
		
		GridBagConstraints gbc_lblRobotstxt = new GridBagConstraints();
		gbc_lblRobotstxt.anchor = GridBagConstraints.EAST;
		gbc_lblRobotstxt.insets = new Insets(5, 5, 5, 5);
		gbc_lblRobotstxt.gridx = 0;
		gbc_lblRobotstxt.gridy = 5;
		controls.add(getLblRobotstxt(), gbc_lblRobotstxt);
		GridBagConstraints gbc_chckbxObeyRules = new GridBagConstraints();
		gbc_chckbxObeyRules.anchor = GridBagConstraints.WEST;
		gbc_chckbxObeyRules.insets = new Insets(5, 5, 5, 5);
		gbc_chckbxObeyRules.gridwidth = 3;
		gbc_chckbxObeyRules.gridx = 2;
		gbc_chckbxObeyRules.gridy = 5;
		controls.add(getObeyRobots(), gbc_chckbxObeyRules);
		GridBagConstraints gbc_exclude_scroll = new GridBagConstraints();
		gbc_exclude_scroll.weighty = 1.0;
		gbc_exclude_scroll.gridwidth = 5;
		gbc_exclude_scroll.insets = new Insets(5, 5, 5, 5);
		gbc_exclude_scroll.fill = GridBagConstraints.BOTH;
		gbc_exclude_scroll.gridx = 0;
		gbc_exclude_scroll.gridy = 6;
		controls.add(getExclude_scroll(), gbc_exclude_scroll);
		
		getContentPane().add(controls, BorderLayout.CENTER);
		getContentPane().add(getButtons(), BorderLayout.SOUTH);
		
		this.btnOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				try {
					SiteOpenDlg.this.document.setRoot(new WebTreeNode(new URL(getSiteURL())));
					SiteOpenDlg.this.document.setMaxDepth(getDepth().getValue());
					SiteOpenDlg.this.document.setContentInMemory(getKeepContent().isSelected());
					SiteOpenDlg.this.document.setObeyRobots(getObeyRobots().isSelected());
					SiteOpenDlg.this.document.setFormTraversing(getFormTraversing().isSelected());
					SiteOpenDlg.this.document.setExcludeURLs(getExcludes().getText());
					// Si cambió el usuario o escribió una clave
					if (!old_username.equals(getUsername().getText()) || getPassword().getPassword().length > 0)
						SiteOpenDlg.this.document.setUsernameAndPassword(getUsername().getText(), getPassword().getPassword());
					
					DRKTools.prefs.put("last_url", getSiteURL());
					DRKTools.prefs.putInt("last_depth", getDepth().getValue());
					DRKTools.prefs.putBoolean("keep_content", getKeepContent().isSelected());
					DRKTools.prefs.putBoolean("obey_robots", getObeyRobots().isSelected());
					DRKTools.prefs.putBoolean("form_traversing", getFormTraversing().isSelected());
					DRKTools.prefs.put("excludes", getExcludes().getText());
					DRKTools.prefs.put("username", getUsername().getText());
					
					ok = true;
					SiteOpenDlg.this.dispatchEvent(new WindowEvent(SiteOpenDlg.this, WindowEvent.WINDOW_CLOSING));
					
				} catch (MalformedURLException e1) {
					JOptionPane.showMessageDialog(SiteOpenDlg.this, "Please enter a valid website address", "Malformed address", JOptionPane.ERROR_MESSAGE);
				}
				
			}
		});
		this.btnCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SiteOpenDlg.this.dispatchEvent(new WindowEvent(SiteOpenDlg.this, WindowEvent.WINDOW_CLOSING));
			}
		});

		
		getRootPane().setDefaultButton(getOk());
		pack();
		setLocation(DRKTools.getCenterLocation(this));
	}
	
	public void showNew() {
		this.setTitle("Crawling parameters for new website...");
		this.document = new WebTreeModel(new WebTreeNode());
		getUrl().setText(DRKTools.prefs.get("last_url", "http://"));
		getDepth().setValue(DRKTools.prefs.getInt("last_depth", 3));
		getKeepContent().setSelected(DRKTools.prefs.getBoolean("keep_content", false));
		getObeyRobots().setSelected(DRKTools.prefs.getBoolean("obey_robots", true));
		getFormTraversing().setSelected(DRKTools.prefs.getBoolean("form_traversing", false));
		getExcludes().setText(DRKTools.prefs.get("excludes", ""));
		getUsername().setText(DRKTools.prefs.get("username", ""));
		setVisible(true);
	}
	
	public void showModify(WebTreeModel document) {
		this.setTitle("Modify crawling parameters...");
		this.document = document;
		getUrl().setText(this.document.getRootNode().getURL().toString());
		getDepth().setValue(this.document.getMaxDepth());
		getKeepContent().setSelected(this.document.isContentInMemory());
		getObeyRobots().setSelected(this.document.getRobots() != null);
		getFormTraversing().setSelected(this.document.isFormTraversing());
		getExcludes().setText(this.document.getExcludeURLs());
		getUsername().setText(this.document.getUsername());
		this.old_username  = this.document.getUsername();
		setVisible(true);
	}

	/**
	 * This method initializes buttons	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getButtons() {
		if (buttons == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout.setVgap(4);
			flowLayout.setHgap(4);
			buttons = new JPanel();
			buttons.setLayout(flowLayout);
			buttons.add(getOk(), null);
			buttons.add(getCancel(), null);
		}
		return buttons;
	}

	/**
	 * This method initializes ok	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getOk() {
		if (btnOk == null) {
			btnOk = new JButton();
			btnOk.setText("OK");
		}
		return btnOk;
	}

	/**
	 * This method initializes cancel	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancel() {
		if (btnCancel == null) {
			btnCancel = new JButton();
			btnCancel.setText("Cancel");
		}
		return btnCancel;
	}

	/**
	 * This method initializes url	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getUrl() {
		if (url == null) {
			url = new JTextField();
			url.setColumns(30);
		}
		return url;
	}

	public String getSiteURL() {
		return url.getText();
	}

	/**
	 * This method initializes slide_depth	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getDepth() {
		if (slide_depth == null) {
			slide_depth = new JSlider();
			slide_depth.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					depth_lbl.setText(Integer.toString(slide_depth.getValue()));
				}
			});
			slide_depth.setMaximum(15);
			slide_depth.setValue(3);
			slide_depth.setSnapToTicks(true);
			slide_depth.setPaintTicks(true);
			slide_depth.setPaintLabels(true);
			slide_depth.setPaintTrack(true);
			slide_depth.setMinimum(1);
		}
		return slide_depth;
	}

	private JCheckBox getKeepContent() {
		if (keepContent == null) {
			keepContent = new JCheckBox("keep content in memory");
		}
		return keepContent;
	}
	private JLabel getLbl3() {
		if (lbl3 == null) {
			lbl3 = new JLabel("Downloaded content:");
		}
		return lbl3;
	}
	
	private JLabel getLblRobotstxt() {
		if (lblRobotstxt == null) {
			lblRobotstxt = new JLabel("robots.txt:");
		}
		return lblRobotstxt;
	}
	
	private JCheckBox getObeyRobots() {
		if (obeyRobots == null) {
			obeyRobots = new JCheckBox("obey rules");
		}
		return obeyRobots;
	}
	
	public WebTreeModel getDocument() {
		return document;
	}

	private JScrollPane getExclude_scroll() {
		if (exclude_scroll == null) {
			exclude_scroll = new JScrollPane();
			exclude_scroll.setViewportBorder(new TitledBorder(null, "Exclude URLs", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			exclude_scroll.setViewportView(getExcludes());
		}
		return exclude_scroll;
	}
	private JTextArea getExcludes() {
		if (excludes == null) {
			excludes = new JTextArea();
			excludes.setToolTipText("Insert one regular expression per row");
			excludes.setRows(5);
		}
		return excludes;
	}
	private JLabel getLblUsernamepassword() {
		if (lblUsernamepassword == null) {
			lblUsernamepassword = new JLabel("Username/password:");
		}
		return lblUsernamepassword;
	}
	private JTextField getUsername() {
		if (username == null) {
			username = new JTextField();
			username.setToolTipText("Leave this field empty if no authentication is required. On edit, leave this field unchanged for keeping previously entered password.");
			username.setColumns(8);
		}
		return username;
	}
	private JPasswordField getPassword() {
		if (password == null) {
			password = new JPasswordField();
			password.setToolTipText("Leave this field empty for keeping previously entered password");
			password.setColumns(10);
		}
		return password;
	}
	private JCheckBox getFormTraversing() {
		if (form_traversing == null) {
			form_traversing = new JCheckBox("Treat forms as links");
			form_traversing.setToolTipText("If checked, the crawler will follow URLs found in forms as it were links. Turn this on if you know what you are doing only.");
		}
		return form_traversing;
	}
	private JLabel getLblFormTraversiong() {
		if (lblFormTraversiong == null) {
			lblFormTraversiong = new JLabel("Form traversing:");
		}
		return lblFormTraversiong;
	}
}
